.286

int_num    EQU  7Ah           ; 墠뢠 뢠

seg_a   segment byte public
        assume cs:seg_a,ds:seg_a
        org     100h

iosim   proc    far

start:
        jmp    install

;
;    ࠡ稪 㤥 뢠 ,  Soft-ICE 㦨   
;  뢠    ACTION 㤥 ⠭   뢠  
;  (ACTION int_num).  ࠬ ।  Soft-ICE   室   
;  ⥪  ᯮ ᫥騬 ࠧ:                                
;                   flags        ॣ 䫠                          
;                   cs           CS:IP 㪠뢠  ,  ன  
;                   ip           㦥 ⠭ breakpoint     
;                   ..                                                
;  ࠡ稪 墠뢠 ᫥騥 :                           
;       0E4h - in  al,port                                               
;       0E5h - in  ax,port                                               
;       0E6h - out port,al                                               
;       0E7h - out port,ax                                               
;       0ECh - in  al,dx                                                 
;       0EDh - in  ax,dx                                                 
;       0EEh - out al,dx                                                 
;       0EFh - out ax,dx                                                 
;                                                                        
;  P.S.  02h 㪠뢠   (in  out),   01h 㪠뢠   
;    ਭ/। 祭 (word  byte).         
;

io_routine proc far
	pusha
	mov	bp,sp
	push	ds
	push    es
        mov     ax,cs
	mov	ds,ax			;⠭ ᥣ 
        mov     ax,[bp].Reg_cs          ;砥 CS ணࠬ ࠡ饩 
                                        ; ⮬
	mov	es,ax			;⠭  ᥣ
	mov	si,[bp].Reg_ip		;砥 㪠⥫ IP   i/o
	mov	al,es:[si-1]		;砥  i/o 樨
        cmp	al,0ECh 	        ; 1 ⮢ i/o ?
        jb	not_io
       	cmp	al,0EFh
        ja	not_io
	mov	dx,[bp].Reg_dx		;砥    ⥪
        jmp     short io_code
not_io:
        mov     dh,00
	mov	dl,al		        ;।    
	mov	al,es:[si-2]		;砥  i/o 樨
        cmp	al,0E4h 	        ; 2- ⮢ i/o ?
        jb	not_an_io
       	cmp	al,0E7h
        ja	not_an_io
io_code:
;       mov     cl,0                    ;।     
                                        ;⮬
;	test	al,01h			;    ᫮?
;	jz	byte_access		;,    ⮬
;	mov	cl,1			;ન㥬    ᫮
byte_access:
	test	al,02h			;  in  out
	jnz	in_out_protocol		;  out


in_opcode:
;
;  室:  cl = byte  word                                     
;               0 = byte                                                 
;               1 = word                                                 
;         dx = i/o                                                   
;         al =  樨                                              
;  室:                                                                
;           [bp].Reg_ax  [bp].Reg_al    㫨஢       
;      祭, ஥    BUFFIN                        
;

        cmp     mode_work, 'S'
        jne     in_out_protocol

	mov	bx,next_in_loc
        cmp     bx,size_in_buf               ; ?
        jae     io_done
        mov     es,addr_in_buf
	mov	cx,es:[bx]                   ;⠥   
	mov	ss:[bp].Reg_ax,cx
	add	next_in_loc,2

in_out_protocol:
;
;     dx = i/o                                                       
;                                                                        
;     [bp].Reg_ax  [bp].Reg_al   砥 祭  뢮       
;

	mov	cx,[bp].reg_ax		;砥 祭 뫠  
	mov	bx,next_out_loc
        cmp     bx,size_out_buf         ; ?
        jae     io_done
        mov     es,addr_out_buf
        mov     byte ptr es:[bx],al     ;࠭塞  믮 樨,
replace:
	mov	es:[bx+1],dx            ;࠭塞   
	mov	es:[bx+3],cx            ;祭 뫠  
	add	next_out_loc,5


io_done:
not_an_io:
	pop	es
	pop	ds
	popa
        iret                            ;頥 ࠢ ᫥ 
                                        ;ࠡ⪨
reg_word struc
reg_di		dw	0
reg_si		dw	0
reg_bp		dw	0
reg_sp		dw	0
reg_bx		dw	0
reg_dx		dw	0
reg_cx		dw	0
reg_ax		dw	0
reg_ip		dw	0
reg_cs		dw	0
reg_flags	dw	0
reg_word ends

reg_byte struc
reg_di1 	dw	0
reg_si1 	dw	0
reg_bp1 	dw	0
reg_sp1 	dw	0
reg_bl		db	0
reg_bh		db	0
reg_dl		db	0
reg_dh		db	0
reg_cl		db	0
reg_ch		db	0
reg_al		db	0
reg_ah		db	0
reg_byte ends

signature     db  'Soft-ICE'

mode_work     db  0             ; ࠡ ணࠬ ('R'  'S')

next_in_loc   dw  0             ;    樨 
next_out_loc  dw  0             ;    ⥭ ⮪ 
                                ;ࠡ
size_in_buf   dw  32            ;  ( )  (512 byte)
size_out_buf  dw  128           ;  ( )  (2046 byte)

addr_in_buf   dw  0
addr_out_buf  dw  0

end_routine:                    ; ࠡ稪

io_routine endp

Install:
        mov     si,81h

next_sym:
        call    del_space
        cmp     al,0Dh
        je      set_interrupt
        cmp     al,'/'
        jne     error
        call    del_space
        cmp     al,'?'
        je      vizitka
        cmp     al,'Z'
        jb      what_mode
        sub     al,20h

what_mode:
        cmp     al,'S'                  ; ० 樨 ?
        jne     is_not_sim_mode
        mov     mode_work,al
        jmp     short next_sym

is_not_sim_mode:
        cmp     al,'R'                  ; ० ⥭ ⮪ ࠡ?
        jne     is_not_read_mode
        mov     mode_work,al
        jmp     short next_sym

is_not_read_mode:
        cmp     al,'I'                  ; ࠧ   IN 権?
        jne     is_not_in_mode
        call    hex_bin
        mov     size_in_buf,cx
        jmp     short next_sym

is_not_in_mode:
        cmp     al,'O'                  ; ࠧ   ⮪?
        jne     error
        call    hex_bin
        mov     size_out_buf,cx
        jmp     short next_sym

error:
        mov     dx, offset err_mes
        mov     ah, 9
        int     21h
        jmp     short Quit

set_interrupt:

        mov     al,mode_work
        or      al,al                   ; ࠡ ⠭?
vizitka:
        je      viza

        mov	bx,offset end_routine   ; ணࠬ
        shr	bx,4                    ;bx- ࠧ ࠡ稪  ࠣ
        inc     bx

        mov     ax,cs
        mov     es,ax
        mov     ah,4Ah
        int     21h                     ;    SIM_IO
                                        ; ࠡ稪 io_routine
        mov     ah,48h
        mov     bx,size_in_buf
        int     21h                     ;뤥    ⥭ IN
        jc      not_mem
        mov     addr_in_buf,ax          ;࠭塞  
        shl     size_in_buf,4           ;࠭塞 ࠧ   

        mov     ah,48h
        mov     bx,size_out_buf
        int     21h                     ;뤥   ⮪
        jc      not_mem
        mov     addr_out_buf,ax         ;࠭塞  
        shl     size_out_buf,4          ;࠭塞 ࠧ   

        mov     dx, offset Inst
        mov     ah, 9
        int     21h                     ;饭  ⠫樨

;        mov     ax,cs                   ;⠭ ᥣ 
        mov     ax,offset io_routine
        mov     ds,ax
	xor	ax,ax			;塞 es ᥣ
	mov	es,ax			;

	mov	ax,offset io_routine	;砥  ࠡ稪 뢠
	mov	es:[int_num*4],ax	;뢠   襣 뢠
	mov	ax,cs
	mov	es:[int_num*4+2],ax	;⠭ CS ᥣ

	mov	ah,31h
	mov	dx,bx
	int	21h			;   १⮬

viza:
        mov     dx, offset info
        mov     ah, 9
        int     21h
quit:
        int     20h

not_mem:
        mov     dx, offset _not_mem
        mov     ah, 9
        int     21h
        jmp     short quit


hex_bin        proc    near     ;Call with
                                ;DS:SI = addr of hex ASCIIZ string
                                ;Returns
				;CY flag = 1 input string illegal
				;  or
				;CY flag = 0 input string legal, and
				;DX:CX = signed 32-bit integer.
                push    ax
                lodsb
                cmp     al,':'
                jne     error
                xor     cx,cx
                xor     dx,dx
hex_bin1:
                lodsb
                cmp     al,' '
                jbe     hex_bin8
                cmp     al,'0'
                jb      hex_bin7
                cmp     al,'9'
                jbe     hex_bin3
hex_bin2:
                or      al,20h
                cmp     al,'f'
                ja      hex_bin7
                cmp     al,'a'
                jb      hex_bin7
                add     al,9
  hex_bin3:
                shl     cx,1
                rcl     dx,1
                shl     cx,1
                rcl     dx,1
                shl     cx,1
                rcl     dx,1
                shl     cx,1
                rcl     dx,1
                and     ax,0fh
                or      cx,ax
                jmp     hex_bin1
  hex_bin7:                       ;illegal input string,
                stc               ;return CY flag = 1
                pop     ax
                pop     ax        ;returned word use on op. CALL
                jmp     error
  hex_bin8:
                clc
                pop     ax
                shr     cx,4      ;returned cx in 16-byting paragraph
                inc     cx        ;rezerved
                dec     si
                ret
hex_bin endp

del_space     proc near
                lodsb
                cmp     al,' '
                je      del_space
                ret
del_space endp


Inst      db  'SIMIO   I/O    V2.0 1993 (C) by Wasilyev S.S.',0dh,0ah
          db  '   ⠫஢    (7A interrupt)',0dh,0ah,"$"

err_mes   db  0Dh,0Ah,'H ࠬ!  ᯮ  "/?".',0dh,0ah,0dh,0ah,'$'

_not_mem  db  0Dh,0Ah,'H 墠⠥   ࠧ饭 ஢!',0dh,0ah,0dh,0ah,'$'

info      db  'SIMIO   I/O    V2.0 1993 (C) by Wasilyev S.S.',0dh,0ah
          db  '   ᪠:  SIMIO  <樨>',0dh,0ah
          db  '               /S       - 㫨஢  (஡ .  )',0dh,0ah
          db  '               /R       -  ⮪ ࠡ ',0dh,0ah
          db  '               /I:XXXX  - ࠧ      権 IN.',0ah,0dh
          db  '                           (  ⥭  㥬  ணࠬ',0ah,0dh
          db  '                             । 祭  ⮣ . ',0ah,0dh
          db  '                               㬮砭 512 . )',0ah,0dh
          db  '               /O:XXXX  - ࠧ     祭 ⮪',0ah,0dh
          db  '                          ࠡ 㥬 .  㬮砭 2 .',0ah,0dh
          db  '     P.S.  ࠡ  ० "/S" ⮬᪨  ⮪ ࠡ',0dh,0ah
          db  '          , ᫨ /O > 0000.  I/O ஢ 室 ',0Dh,0ah
          db  '          HEX .  ଠ쭮 ࠡ ᯮ ணࠬ IORead.exe.',0ah,0dh,0ah,0dh
          db  '   SIMIO 墠뢠  ࠡ뢠 ᫥騥 :',0dh,0ah
          db  '             0E4h - in  al,port',0ah,0dh
          db  '             0E5h - in  ax,port',0ah,0dh
          db  '             0E6h - out port,al',0ah,0dh
          db  '             0E7h - out port,ax',0ah,0dh
          db  '             0ECh - in  al,dx',0dh,0ah
          db  '             0EDh - in  ax,dx',0ah,0dh
          db  '             0EEh - out al,dx',0ah,0dh
          db  '             0EFh - out ax,dx','$'



iosim      endp
seg_a ends

end start
